dnl ---=|=--- default.m4 ---=|=---
dnl ---=--- Default values for macros ---=---


Provide({defaults},{


dnl --- Pseudo-ASM instructions ---
dnl
defdef({Mov}, {ifelse({$1},,,{$2},,,{$1},{$2},,{__Mov__($1,$2)})})
defdef({Xchg},{ifelse({$1},,,{$2},,,{$1},{$2},,{__Xchg__($1,$2)})})

defdef({AddIm},{Add($1,$2)})
defdef({Inc},{AddIm($1,1)})
defdef({Dec},{AddIm($1,-1)})

defdef({Shr},{ifelse($2,,{__Shr__($1,1)},{__Shr__($1,$2)})})
defdef({Shl},{ifelse($2,,{__Shr__($1,1)},{__Shl__($1,$2)})})


dnl --- Branching & Loops ---
dnl
ifdef({Ifcompare},
   {defdef({Branch},{Ifcompare({$1},{$2},{$3},{Goto($4)})})})
ifdef({Branch},
   {defdef({Ifcompare},
      {pushdef({elsetarget},newlabel)
       pushdef({exittarget},newlabel)
         Branch(negcond({$1}),{$2},{$3},elsetarget)
	 $4
	 ifelse({$5},{},{},{Goto(exittarget)})
	elsetarget:
	 ifelse({$5},{},{},{$5})
	exittarget:
       popdef({elsetarget})
       popdef({exittarget})
})})dnl Ifcompare(cond,arg1,arg2,ifclause,opt elseclause)

defdef({Repeat},
      {pushdef({repeattarget},newlabel)
       pushdef({exittarget},newlabel)
	repeattarget:
	 $1
	 Branch({$2},{$3},{$4},{repeattarget})
	exittarget:
       popdef({repeattarget})
       popdef({exittarget})
})dnl Repeat(repeatclause,cond,arg1,arg2) continues *while* cond is true
defdef({While},
      {pushdef({whiletarget},newlabel)
	Goto(whiletarget)
	Repeat({$5
	whiletarget: $1},{$2},{$3},{$4})
       popdef({whiletarget})
})dnl While(compcond,cond,arg1,arg2,whileclause) continues *while* cond is true
defdef({Loop},{While({},{nz},{COUNT},{0},{__Seq__({$1},{Dec(COUNT)})})})
defdef({Loopno0},{Repeat({__Seq__({$1},{Dec(COUNT)})},{nz},{COUNT},{0})})


dnl --- Syntax ---
dnl
defdef({__Seq__},{ifelse({$*},,,{shift($@)},,{$1}{Terminator},
	        {$1{}Terminator{}Separator{}__Seq__(shift($@))})})
defdef({Seq},{Begin __Seq__($@) End})
defdef({labelprefix},{Forth_})


dnl --- Register Convention ---
dnl
defdef({MDSINC},	{(-DSINC)})dnl	increment for data stack
defdef({DSINC},		{(-MDSINC)})dnl	increment for data stack
defdef({MRSINC},	{(-RSINC)})dnl	increment for data stack
defdef({RSINC},		{(-MRSINC)})dnl	increment for data stack
defdef({DSE},{point(DSP,$1)})
defdef({NOS},{DSE(0)})
defdef({TSE},{DSE(1)})
defdef({FSE},{DSE(2)})
defdef({Nip},{AddIm(DSP,ifelse({$1},{},{MDSINC},{$1*MDSINC}))})
defdef({Pin},{AddIm(DSP,ifelse({$1},{},{DSINC},{$1*DSINC}))})
defdef({PopmData}, {__Seq__({Mov(TOS,DSE(ifelse({$1},{},0,$1-1)))},
				{Nip($1)})})
defdef({PopData}, {__Seq__({Mov($1,TOS)},{Mov(TOS,NOS)},{Nip})})
defdef({PushData},{__Seq__({Pin},{Mov(NOS,TOS)},{Mov(TOS,$1)})})
defdef({RSE},{point(RSP,$1)})
defdef({TORS},{RSE(0)})
defdef({NORS},{RSE(1)})
defdef({DropReturn},{AddIm(RSP,ifelse({$1},{},{MRSINC},{$1*MRSINC}))})
defdef({PordReturn},{AddIm(RSP,ifelse({$1},{},{RSINC},{$1*RSINC}))})
defdef({PopmReturn}, {__Seq__({Mov(TOS,RSE(ifelse({$1},{},0,$1)))},
				{DropReturn($1)})})
defdef({PopReturn}, {__Seq__({Mov($1,RSE(0))},{DropReturn})})
defdef({PushReturn},{__Seq__({ProdReturn},{Mov(RSE(0),$1)})})


dnl --- Calling Convention ---
dnl
defdef({_Enter_},{AddIm(PC,$1)})
defdef({Enter},{ifelse($#,0,{_Enter_(PCINC)},
		{Mov($1,point(PC,PCINC))
		 _Enter_(2*PCINC)})})
defdef({Next},{Goto(point(PC))})
defdef({Call_LLL},
{irp(X,reverse(shift($@)),{PushData(X)})
local({Sequel,T1},{
PushReturn(PC)
Call(T1)
T1:
AddIm(point(RSP),ival(pval(Sequel)-pval(T1)))
Mov(PC,RSP)
AddIm(PC,RSINC)
Goto($1)
Sequel:
PopReturn(PC)
})})


dnl --- Defining a FORTH word ---
dnl
dnl  * to define a FORTH word,
dnl  * ....
dnl  * add an entry in a m4 table, so that we can later
dnl    simulate FORTH compilation from within m4,
dnl    provided the only meta-words used were built into the m4 files...
dnl ......
dnl

defdef({Label},{OSLK_$1})
defdef({DefSymbol},
{__symbolseg__({
   defcell(StringAddress($1))dnl	the name string
   defcell(SymbolFlags($2))dnl		flags
   defcell(SymbolValue($3))dnl		pointer to the value
})})

define({__DefWord__},
{pushdef({FWLABEL},Label($2))
DefString({DefSymbol(strbeg,{$3},FWLABEL)},{$1})
FWLABEL:
popdef({FWLABEL})
})
define({__DefAlias__},
{DefString({DefSymbol({strbeg},{$3},Label({$4}))},{$1})
Equate(Label({$2}),Label({$4}))
})


defdef({DefWord},
   {__DefWord__({$1},ifelse({$2},,{{$1}},{{$2}}),shift(shift($@)))})
defdef({DefAlias},
   {__DefAlias__({$1},ifelse({$2},,{{$1}},{{$2}}),shift(shift($@)))})


dnl --- Constant values ---
dnl
defdef({TRUE},{-1})	dnl -- Logical True value
defdef({FALSE},{0})	dnl -- Logical False value


dnl --- Deduced values ---
dnl
defdef({CHARSIZE},eval(1 << CHARABITS))dnl --	size of a char in bytes
defdef({WORDSIZE},eval(1 << WORDABITS))dnl --	size of a char in bytes
defdef({CELLSIZE},eval(1 << CELLABITS))dnl --	size of a cell in bytes
defdef({PAGESIZE},eval(1 << PAGEABITS))dnl --	size of a page in bytes
defdef({CHARMASK},(eval(~ (CHARSIZE - 1))))dnl -- mask of chars in address
defdef({WORDMASK},(eval(~ (WORDSIZE - 1))))dnl -- mask of words in address
defdef({CELLMASK},(eval(~ (CELLSIZE - 1))))dnl -- mask of cells in address
defdef({PAGEMASK},(eval(~ (PAGESIZE - 1))))dnl -- mask of pages in address
defdef({BITSPERCHAR},eval(CHARSIZE*BYTEBITS))dnl --	bits in a char
defdef({BITSPERCELL},eval(CELLSIZE*BYTEBITS))dnl --	bits in a cell


})dnl ----- end of defaults.m4 -----
dnl
