dnl ----------------- General purpose m4 Macro library ----------------------
dnl (c) Franois-Ren "Far" Rideau Dang-Vu Bn 1995
dnl
dnl see info file .../doc/info/m4macros.nfo (section * macro.m4::)
dnl
divert(-1)

changequote(`{',`}')


------ m4 Modules ------

define({Provide},{ifdef({$$Provided_$1},,
	{define({$$Provided_$1},{YES})dnl
	$2{}_VERBOSEln_({Provided $1})})})
define({Require},{ifdef({$$Provided_$1},,
	{_VERBOSE_({Requiring $1... })include({$1.m4})dnl})})
define({defdef},{ifdef({$1},{forget},{define})({$1},{$2})})})



Provide({macro},{

------ Constants ------

define({__nl__},{
})


------ Argument mangling ------

define({forget},)
define({nargs},{$#})
define({expand0},$*)
define({expand},{expand0($*)})
define({quote},{{{$*}}})
define({quoteargs},{{$@}})
define({head},{$1})
define({tail},{shift($@)})
define({cat9},{{}$1{}$2{}$3{}$4{}$5{}$6{}$7{}$8{}$9{}})
define({cat},
	{ifelse($#, 0,,
		$#, 1,{$1},
		{format({%s{}%s},{$1},{cat(shift($@))})})})
define({reverse}, {ifelse($#, 0, , $#, 1, {{$1}},
     			  {reverse(shift($@)), {$1}})})
define({accumulate},{accumulate_({$1},$1({$2}))})
define({accumulate_},
	{ifelse({$2},{},,{$3},{{}},{{$2}},
		{{$2},accumulate_({$1},$1($3))})})

define({quote2},{{$1},{$2}})
define({defnz},{ifelse({$2},{},,{$2},,,{$2},{{}},,{define({$1},{$2})})})


------ Character access ------

define({split_char},
{regexp({$*},{^\(.\)\(\(.*}__nl__{?\)*\)$},{{{\1}},{{\2}}})})
define({read_char},{_2_def_1_3({$1},split_char(defn({$1})))})
define({_2_def_1_3},{$2{}define({$1},$3)})
define({char_list},{accumulate({split_char},{$1})})
define({reversechars},{cat(reverse(char_list($1)))})
define({upcase},  {translit({$*},{a-z},{A-Z})})
define({downcase},{translit({$*},{A-Z},{a-z})})


------ Loops ------

define({forloop},
{pushdef({$1}, {eval($2)})_forloop({$1}, {$2}, {$3}, {$4})popdef({$1})})
define({_forloop},
	{$4{}ifelse($1, {$3}, ,
		{define({$1}, incr($1))_forloop({$1}, {$2}, {$3}, {$4})})})
define({rept},
	{ifelse(eval({$1>0}),1,
		{forloop({i},{1},{$1},{$2})})})
define({irp},
{pushdef({$1})dnl
pushdef({_loop_body_$1},{shift(shift($@))})dnl
_irp({$1}, $2){}dnl
popdef({_loop_body_$1})dnl
popdef({$1})})
define({_irp},
	{ifelse($#, 1,,
		$#, 2,{_irp_once({$1},{$2})},
		{_irp_once({$1},{$2}){}_irp({$1},shift(shift($@)))})})
define({_irp_once},
dnl	{define({$1},{$2})expand(_loop_body_$1){}})
	{define({$1},{$2})expand(_loop_body_$1)})

------ Counters ------

define({addvar},
	{define({$1},eval($2+$1))})
define({incrvar},
	{define({$1},incr($1))})
define({varadd},
	{cat($1,addvar({$1},{$2}))})
define({varincr},
	{cat($1,incrvar({$1}))})


------ Stream Variables ------

define({AppendVar},
	{define({$1},defn({$1}){$2})})
define({PrependVar},
	{define({$1},{$2}defn({$1}))})
define({AppendList},
	{ifdef({$1},
		{define({$1},defn({$1}){,$2})},
		{define({$1},{$2})})})
define({PrependList},
	{ifdef({$1},
		{define({$1},{$2,}defn({$1}))},
		{define({$1},{$2})})})


------ min, max ------

define({max},{ifelse(eval(($1)>($2)),1,$1,$2)})
define({min},{ifelse(eval(($1)<($2)),1,$1,$2)})


------ local labels ------

define({labelprefix},{L})
define({currentlabel},{0})
define({newlabel},{format({%s%04X},labelprefix,varincr({currentlabel}))})
define({local},
	{cat9({pushdef({$1},newlabel)},{$2},{popdef({$1})})})
define({locals},
	{ifelse($#,0,,
		$#,1,{$1},
		{local({$1},{locals(shift($@))})})})


------ metastacks ------

define({__newstk__},
    {define({__sp__$1},0)})
define({__push__},
    {incrvar({__sp__$1})define({__stk__$1__}__sp__$1,{$2})})
define({__pop__},
    {addvar({__sp__$1},-1)})
define({__pick__},
    {defn({__stk__$1__}eval(__sp__$1-ifelse({$2},,0,{$2})))})


------ diverting ------

define({__numdiversion__},1)

define({indiversion},
cat9(	{{pushdef({__currentdiversion__},divnum)}},
	{{divert($1)}},
	{{$2}},
	{{divert(__currentdiversion__)}},
	{{popdef({__currentdiversion__})}}))

define({declarediversion0},
{define({$1},{indiversion($2,{$3})})})
define({declarediversion},
{declarediversion0({$1},varincr({__numdiversion__}),{$}{*})})


------ reverse diversions ------

define({__revidsion_list__})

define({inrevidsion},
{PrependVar({$$revidsion:$1},{$2})})

define({declarerevidsion0},
{define({$1},{inrevidsion($2,{$3})})
AppendList({__revidsion_list__},{$2})
define({$$revidsion:$2})
})

define({declarerevidsion},
{declarerevidsion0({$1},varincr({__numdiversion__}),{$}{*})})

define({flush_revidsion},
{indiversion($1,
	{indir({$$revidsion:$1})})
dnl undefine({$$revidsion:$1})
})

define({flush_revidsions},
{irp({revidsionnum},{shift(__revidsion_list__)},
	{{flush_revidsion}(revidsionnum)})})


------ Error output ------

define({_OUT_},{errprint($@)})
define({_OUTln_},{errprint($@{}__nl__)})
define({_VERBOSE_},{ifdef({__VERBOSE__},{_OUT_({$*})})})
define({_VERBOSEln_},{ifdef({__VERBOSE__},{_OUTln_({$*})})})



------ Regular Expressions -----
define({__REGEXP_BLANK__},{[
 	]})
define({__REGEXP_NOBLANK__},{[^
 	]})
define({__REGEXP_ANY__},{\(.\|
\)})


------ Scoping ------

define({__Name__},{defn({$$Current_Module})_{$1}})
define({__Define__},{define(Name($1),{$2})})
define({DefineModule},
{pushdef({$$Current_Module},Name($1))
$2
popdef({$$Current_Module})})

})dnl ------------------------- end of macro.m4 ------------------------------

divert{}dnl
